/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: at91skyeye.h 619 2014-03-18 06:10:27Z nmir-saito $
 */

#ifndef TOPPERS_AT91SKYEYE_H
#define TOPPERS_AT91SKYEYE_H

#include <sil.h>

/*
 * ߥϥɥֹ椫顤IRCΤΥӥåȥѥޥ
 */
#define INTNO_BITPAT(intno) (1U << intno)

/*
 *  ߥȥط
 */
#define AIC_IVR      (0xFFFFF100)
#define AIC_ISR      (0xFFFFF108)
#define AIC_IMR      (0xFFFFF110)
#define AIC_IECR     (0xFFFFF120)
#define AIC_IDCR     (0xFFFFF124)
#define AIC_ICCR     (0xFFFFF128)
#define AIC_EOI      (0xFFFFF130)
#define AIC_IPR      (0xFFFFF10C)

#define IRQ_USART0      2
#define IRQ_TC1         5

/*
 *  ޴Ϣ
 */
#define TIMER_1_CCR      (0xFFFE0040)
#define TIMER_1_CMR      (0xFFFE0044)
#define TIMER_1_CV       (0xFFFE0050)
#define TIMER_1_SR       (0xFFFE0060)
#define TIMER_1_RC       (0xFFFE005C)
#define PIT_PIVR         (0xFFFFFD38)

/*
 * ǥХޥ͡ΥޥץåǽؤΥ쥸
 * skyeyeconfե礵 
 */
#define MUTEX_ID_REG     (0xFFFFFF00)
#define MUTEX_CNT_REG    (0xFFFFFF04)
#define IPI_REG          (0xffffff80)

/*
 *  UARTϢ
 */
#define USART0_THR       (0xFFFD001C)  // USART Transmitter Holding Register
#define USART0_RPR       (0xFFFD0030)  // USART Receive Pointer Register
#define USART0_RCR       (0xFFFD0034)  // USART Receive Counter Register
#define USART0_CSR       (0xFFFD0014)  // USART Channel Satus Register
#define USART0_IER       (0xFFFD0008)  // USART Interrupt Enable Register
#define USART0_IDR       (0xFFFD000C)  // USART Interrupt Disable Register

/* 
 *  륫󥿴Ϣ 
 */ 
#define CYCLE_COUNTER_REG (0xFFFFFFC0)

/*
 *  С쥸
 */
#define SKYEYE_VER_REG  (0xFFFE1000)
#define DEVM_VER_REG    (0xFFFE1010)

#ifndef TOPPERS_MACRO_ONLY

/*
 * IRCؿ
 */

/*
 * ׵Υޥ
 */
Inline void
at91skyeye_disable_int(uint32_t mask)
{
    sil_wrw_mem((void *)(AIC_IDCR), mask);
}

/*
 * ׵Υޥβ
 */
Inline void
at91skyeye_enable_int(uint32_t mask)
{
    sil_wrw_mem((void *)(AIC_IECR), mask);
}

/*
 * ׵Υꥢ
 */
Inline void
at91skyeye_clear_int(uint32_t mask)
{
    sil_wrw_mem((void *)(AIC_ICCR), mask);	
}

/*
 * ׵Υå
 */
Inline bool_t
at91skyeye_probe_int(uint32_t mask)
{
    return((sil_rew_mem((void *)(AIC_IPR)) & mask) == mask);
}

/*
 * λ
 */
Inline void
at91skyeye_exit(void)
{    
}

/* 
 *  륫󥿤ɤ߹ 
 */ 
Inline uint32_t 
cycle_counter_get_current(void)
{ 
        return sil_rew_mem((void*)(CYCLE_COUNTER_REG)); 
}

/*
 *  ȥ졼˴ؤ
 *  륫󥿤Ѥ롥
 */
#define TRACE_GET_TIM()   cycle_counter_get_current()

#endif /* TOPPPERS_MACRO_ONLY */


#endif /* TOPPERS_AT91SAM7S_H */
